Roborobo3
=========

Roborobo is a fast and simple 2D mobile robot simulator written in C++ loosely based on a khepera/epuck model. It is targeted for fast single and multi-robots simulation (primary motivation is evolutionary robotics et swarm/collective robotics).

Roborobo version 3 is currently the __only__ supported version. Current official release is (from: *roborobo.cpp*):
 * *gVersion = 20181012*
 * *gCurrentBuildInfo = Roma build*

###### __Dependencies__
 * SDL2
 * SDL2_image
 * boost (headers-only)
 * eigen (only for echo state networks) 

###### __Platforms__
 * Linux-based
 * MacOSX
 * previously tried on: MS Windows, Raspbian, Pandora (though no support is provided)

###### __Main author__
 * nicolas.bredeche(at)sorbonne-universite.fr
 * http://pages.isir.upmc.fr/~bredeche/

###### __Other contributors__

 * Thanks to J.-M. Montanier, E. Haasdijk, B. Weel, A. Boumaza, A. Steyven, L. Cazenille, T. Grohens, P. Ecoffet, and many others.

Installation and F.A.Q.
=======================

 * Check _INSTALL.TXT for __installation guide__ (incl. quick start).
 * Check _README.TXT for a __quick introduction__.
 * Check _FAQ.TXT for __trouble shooting__ and __frequently asked questions__.

How to cite roborobo in your publications
=========================================

If you use roborobo in your work, __please cite the following paper__:

*N. Bredeche, J.-M. Montanier, B. Weel, and E. Haasdijk. Roborobo! a fast robot simulator for swarm and collective robotics. CoRR, abs/1304.2888, 2013.*

The paper is available on Arxiv: http://arxiv.org/abs/1304.2888 

Thanks!
